#include "SqcApp.h"

SqcApp *a;

void controlBar_setup()
{
	std::vector < std::string > cBarOpt(get_option("controlBar"));
	if (cBarOpt.size() >= 2) {
		if (!cBarOpt[1].compare("hide")) {
			a->w->controlBar->clear();
			a->w->controlBar->do_callback((Fl_Widget *) a->w);
		} else
			a->w->controlBar->set();
	}
}

void manager_setup()
{
	a->m->currentFrame = 0;
	a->m->currentTime = 0.0;
	
	std::vector < std::string > resScale(get_option("resScale"));
	
	if (resScale[1].compare("1") == 0) {
		a->m->resScale = 1.0;
		a->w->fullRes->setonly();
	} else if (resScale[1].compare("3/4") == 0) {
		a->m->resScale = 3.0 / 4.0;
		a->w->threeQuarters->setonly();
	} else if (resScale[1].compare("2/3") == 0) {
		a->m->resScale = 2.0 / 3.0;
		a->w->twoThirds->setonly();
	} else if (resScale[1].compare("1/2") == 0) {
		a->m->resScale = 1.0 / 2.0;
		a->w->half->setonly();
	} else if (resScale[1].compare("1/3") == 0) {
		a->m->resScale = 1.0 / 3.0;
		a->w->third->setonly();
	} else if (resScale[1].compare("1/4") == 0) {
		a->m->resScale = 1.0 / 4.0;
		a->w->quarter->setonly();
	} else {
		a->m->resScale = 1.0;
		a->w->fullRes->setonly();
	}
}

void setup()
{
	a->w->viewport->parentApp = (void *)a;
	a->w->append->callback((Fl_Callback *) append_browser_cb, a);
	a->w->clearb->callback((Fl_Callback *) clear_images_cb, a);
	
	//scale callbacks
	a->w->fullRes->callback((Fl_Callback *) set_res_scale_cb, a);
	a->w->threeQuarters->callback((Fl_Callback *) set_res_scale_cb, a);
	a->w->twoThirds->callback((Fl_Callback *) set_res_scale_cb, a);
	a->w->half->callback((Fl_Callback *) set_res_scale_cb, a);
	a->w->third->callback((Fl_Callback *) set_res_scale_cb, a);
	a->w->quarter->callback((Fl_Callback *) set_res_scale_cb, a);
	
	a->w->progress->callback((Fl_Callback *) progress_cb, a);
	a->w->begin->callback((Fl_Callback *) begin_cb, a);
	a->w->fback->callback((Fl_Callback *) fback_cb, a);
	a->w->back->callback((Fl_Callback *) back_cb, a);
	a->w->fplay->callback((Fl_Callback *) fplay_cb, a);
	a->w->play->callback((Fl_Callback *) play_cb, a);
	a->w->endb->callback((Fl_Callback *) endb_cb, a);
	a->w->fit->callback((Fl_Callback *) fit_cb, a);
	a->w->orig->callback((Fl_Callback *) orig_cb, a);
	
	manager_setup();
	controlBar_setup();
}

int main(int argc, char **argv)
{
	SqcWindow *w = new SqcWindow();
	SqcManager *m = new SqcManager();
	a = new SqcApp();
	a->w = w;
	a->m = m;
	a->w->set();
	a->w->show();
	setup();
	clear_images_cb(NULL, a);
	if (argc > 1) {
		a->append_images(argc, argv);
	}
	int ret = Fl::run();
	delete w;
	delete m;
	delete a;
	return ret;
}
