#ifndef SQCAPP_H
#define SQCAPP_H

#ifdef _WIN32
#define SQ_COLS_ORDER GL_BGRA_EXT
#else
#define SQ_COLS_ORDER GL_BGRA
#endif

// #include <iostream>
#include "SqcWindow.h"
#include <FL/Fl_File_Chooser.H>
#if FL_MAJOR_VERSION==1
#if FL_MINOR_VERSION==3
#include <FL/Fl_Native_File_Chooser.H>
#endif
#endif
#include "SqcManager.h"
#include <FL/Fl.h>

typedef struct _SqcApp {
	SqcWindow *w;
	SqcManager *m;
	void append_images(int argc, char **argv);
	void append_images_dnd(int dndlen, const char *dndbuf);
} SqcApp;

void fit_cb(void *, SqcApp *);
void orig_cb(void *, SqcApp *);
void progress_cb(void *, SqcApp *);
void begin_cb(void *, SqcApp *);
void fback_cb(void *, SqcApp *);
void back_cb(void *, SqcApp *);
void fplay_cb(void *, SqcApp *);
void play_cb(void *, SqcApp *);
void endb_cb(void *, SqcApp *);
void append_browser_cb(void *, SqcApp *);
void set_res_scale_cb(void *cb, SqcApp * a);
void clear_images_cb(void *, SqcApp *);

#endif
